require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    die("Never use <bits/mathinline.h> directly; include <math.h> instead.");
}
if(defined(&__cplusplus)) {
    eval 'sub __MATH_INLINE () { &__inline;}' unless defined(&__MATH_INLINE);
} else {
    eval 'sub __MATH_INLINE () { &extern  &__inline;}' unless defined(&__MATH_INLINE);
}
if(defined (defined(&__GNUC__) ? &__GNUC__ : 0)  && !defined (defined(&_SOFT_FLOAT) ? &_SOFT_FLOAT : 0)) {
    if(defined(&__USE_ISOC99)) {
	if(! &__GNUC_PREREQ (2,97)) {
	    eval 'sub __unordered_cmp {
	        my($x, $y) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__unordered_cmp);
	    undef(&isgreater) if defined(&isgreater);
	    undef(&isgreaterequal) if defined(&isgreaterequal);
	    undef(&isless) if defined(&isless);
	    undef(&islessequal) if defined(&islessequal);
	    undef(&islessgreater) if defined(&islessgreater);
	    undef(&isunordered) if defined(&isunordered);
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q(( &__unordered_cmp ($x, $y) >> 2& 1));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & 6) != 0));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q(( &__unordered_cmp ($x, $y) >> 3& 1));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & 0xa) != 0));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & 0xc) != 0));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        my($x, $y) = @_;
    		eval q(( &__unordered_cmp ($x, $y) & 1));
	    }' unless defined(&isunordered);
	}
	if( &__GNUC_PREREQ (2, 8)) {
	}
    }
    if(!defined (defined(&__NO_MATH_INLINES) ? &__NO_MATH_INLINES : 0)  && defined (defined(&__OPTIMIZE__) ? &__OPTIMIZE__ : 0)) {
	if(defined(&__USE_ISOC99)) {
	    unless(defined(&__powerpc64__)) {
	    }
	}
    }
    if(defined(&__LIBC_INTERNAL_MATH_INLINES)) {
	require 'sysdep.ph';
	require 'ldsodefs.ph';
	require 'dl-procinfo.ph';
	if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 64|| defined (defined(&_ARCH_PWR4) ? &_ARCH_PWR4 : 0)) {
	    eval 'sub __CPU_HAS_FSQRT () {1;}' unless defined(&__CPU_HAS_FSQRT);
	} else {
	    eval 'sub __CPU_HAS_FSQRT () {(( &GLRO( &dl_hwcap) &  &PPC_FEATURE_64) != 0);}' unless defined(&__CPU_HAS_FSQRT);
	}
    }
}
1;
